<?php

/*
*	Syndeo CMS (former Site@School)
* 	is a website management system designed for primary schools.
* =============================================================================== *
* History Site@School:
* Original idea, coding (version 1.0) and design : Mark de Haan (mark@starwave.nl)
* Ideas, improvements, expansions (versions 1.1 - 2.4): 
* Karin Abma, Dirk Schouten and Fred Stuurman
* Coding version 1.1 - 2.4.10 Fred Stuurman
* =============================================================================== *
* Syndeo CMS Software Version: 2.8.00  
* Copyright (C) 2009: Fred Stuurman (fc.stuurman@hccnet.nl)
* file_functions.php: last changed 26/02/2009 by Fred Stuurman (fc.stuurman@hccnet.nl)
* $Id$
* =============================================================================== *
*/

//functions used by album module, filemanager and fckeditor filemanager

function make_thumb($image, $new_size, $end)
{
//function to create a thumb (smaller version) from the image and with the size given
// $end can be _t or _m
	$thumb = make_thumb_name($image, $end) ;

	if (file_exists($thumb))
	{
		// thumbnail exists, just return the thumbname
		return $thumb;
	}
	else
	{
		if (file_exists($image))
		{
			@set_time_limit(30);
			// thumbnail does not exist
			if (function_exists('imagecreatetruecolor'))
			{
				// use gdlib to resize images      
				//print "GDlib exists making $thumb";  
				//exit;
				ini_set('memory_limit', '100M');
				
				$size = getimagesize($image);
				$x = $size[0];
				$y = $size[1];

				if ($x < $y)
				{
					$newy = $new_size;
					$newx = $x / ($y / $newy);
				}
				else
				{
					$newx = $new_size;
					$newy = $y / ($x / $newx);
				}
				$tmp = explode(".", $image);
				$ext = array_pop($tmp);

				if(($x > $new_size)	OR ($y > $new_size)) //size is to big we need to resize
				{
					if (strtoupper($ext) == "JPG")
					{
						$src_img = imagecreatefromjpeg($image);
						$dst_img = ImageCreateTrueColor($newx, $newy);
						imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $newx, $newy, $x, $y);
						imagejpeg($dst_img, $thumb, "90");
						imagedestroy($src_img);
						imagedestroy($dst_img);
						return $thumb;
					}
					elseif (strtoupper($ext) == "PNG")
					{
						$src_img = imagecreatefrompng($image);
						$dst_img = ImageCreateTrueColor($newx, $newy);
						imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $newx, $newy, $x, $y);
						imagepng($dst_img, $thumb, "9"); //changed for php 5.x from 100 -> 9
						imagedestroy($src_img);
						imagedestroy($dst_img);
						return $thumb;
					}
					elseif (strtoupper($ext) == "GIF")
					{
						$src_img = @imagecreatefromgif($image);
						$dst_img = @ImageCreateTrueColor($newx, $newy);
						imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $newx, $newy, $x, $y);
						imagegif($dst_img, $thumb, "100");
						imagedestroy($src_img);
						imagedestroy($dst_img);
						return $thumb;
					}
					else
					{
						return $image;
					}
				}
				else
				{
					return $image;
				}
			}
		}
	}
}

//create the thumb name from the picture filename: picture_t.jpg 
function make_thumb_name($name, $end)
{
	$tmp = explode(".", $name);
	$ext = array_pop($tmp);
	$name = implode(".", $tmp);
	$thumb = str_replace("//", "/", $name . $end . "." . $ext);
	return $thumb ;
}

function list_suspicious_files($target)
{
//function to scan media and studentpages directory for malicious executable files.
	global $sas_config;
	$count = 0 ;

	$exceptions = array (
		".",
		"..",
		".htaccess"
	); //skip those
	$valid_types = explode(",", $sas_config['valid_file_extentions']);

	$sas_path = $sas_config['serverpath'] . $sas_config['user_path'] . "/";

	$dh = opendir($sas_path . $target);

	while (false !== ($file_name = readdir($dh)))
	{
		if (!in_array($file_name, $exceptions))
		{
			if (is_dir($sas_path . $target . "/" . $file_name))
			{
				// recurse subdirectory; call of function recursive
				$count1 = list_suspicious_files($target . "/" . $file_name);
				$count = $count + $count1;
			}
			elseif (is_file($sas_path . $target . "/" . $file_name))
			{
				$tmp = explode(".", $file_name); //get the file extention.
				if (count($tmp) > 1) //if there is one entry , the files has no extention
				{
					$ext = array_pop($tmp);
				}
				else
				{
					$ext = "" ;
				}
				if ((!in_array(strtolower($ext), $valid_types)) AND ($ext != "")) //is it in the list?
				{
					print "<INPUT type=\"checkbox\" name=\"delete_list[]\" value=\"" . $target . "/" . $file_name . "\">&nbsp;<b>" . $target . "/" . $file_name . "</b><br>";
					$count++ ; //raise the file count
				}
			}
		}
	}

	closedir($dh);
	return $count;

} // end of the 'list_suspicious_files()' function

?>