<?php
/*
TinyBrowser 1.41 - A TinyMCE file browser (C) 2008  Bryn Jones
(author website - http://www.lunarvis.com)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    Modified for Syndeo CMS Software Version: 2.8.00  
    folders.php: last changed 26/02/2009 by Fred Stuurman (fc.stuurman@hccnet.nl)
    Copyright (C) 2009: Fred Stuurman (fc.stuurman@hccnet.nl)
*/
if (!defined('IN_SAS'))
{
	die("Hacking attempt");
}

// Assign browsing options
$actionnow = (isset($_POST['editaction']) ? $_POST['editaction'] : 'create' );

// Initalise alert array
$notify = array(
	'type' => array(),
	'message' => array()
);
$createqty = 0;
$deleteqty = 0;
$renameqty = 0;
$errorqty = 0;
	
// Create any child folders with entered name
if(isset($_POST['createfolder']))
{
	foreach($_POST['createfolder'] as $parent => $newfolder)
	{
		if($newfolder != '')
		{
			$createthisfolder = $tinybrowser['docroot'].$dirpath.urldecode($_POST['actionfolder'][$parent]).remove_special_characters($newfolder);
			if (!file_exists($createthisfolder) && createfolder($createthisfolder,$tinybrowser['unixpermissions'])) $createqty++; else $errorqty++;
		}
	}
}
	
// Delete any checked folders
if(isset($_POST['deletefolder']))
{
	foreach($_POST['deletefolder'] as $delthis => $val)
	{
		$delthisdir = $tinybrowser['docroot'].$dirpath.urldecode($_POST['actionfolder'][$delthis]);
		if (is_dir($delthisdir) && rmdir($delthisdir)) $deleteqty++; else $errorqty++;
		if($foldernow==urldecode($_POST['actionfolder'][$delthis]))
        {
			$foldernow = '';
			$passfolder = '';
        }
	}

}
	
// Rename any folders with changed name
if(isset($_POST['renamefolder']))
{
	foreach($_POST['renamefolder'] as $namethis => $newname)
	{
		$urlparts = explode('/',rtrim(urldecode($_POST['actionfolder'][$namethis]),'/'));
		if(array_pop($urlparts) != $newname)
		{
			$namethisfolderfrom = $tinybrowser['docroot'].$dirpath.urldecode($_POST['actionfolder'][$namethis]);
			$renameurl = implode('/',$urlparts).'/'.remove_special_characters($newname).'/';
			$namethisfolderto = $tinybrowser['docroot'].$dirpath.$renameurl;
			if (is_dir($namethisfolderfrom) && rename($namethisfolderfrom,$namethisfolderto)) $renameqty++; else $errorqty++;
				if($foldernow==urldecode($_POST['actionfolder'][$namethis]))
				{
					$foldernow = ltrim($renameurl,'/');
					$passfolder = '&folder='.urlencode(ltrim($renameurl,'/'));
				}
		}
	}
}

// Assign directory structure to array
$dirs=array();
dirtree($dirs,'*.*',$tinybrowser['docroot'],$tinybrowser['path'][$typenow]);
sort($dirs);
//print_r($dirs);
// generate alert if folders deleted
if($createqty>0)
{
	$notify['type'][]='success';
	$notify['message'][]=sprintf(TB_MSGCREATE, $createqty);
}
// generate alert if folders deleted
elseif($deleteqty>0)
{
	$notify['type'][]='success';
	$notify['message'][]=sprintf(TB_MSGDELETE, $deleteqty);
}
// generate alert if folders renamed
elseif($renameqty>0)
{
	$notify['type'][]='success';
	$notify['message'][]=sprintf(TB_MSGRENAME, $renameqty);
}
	
// generate alert if file errors encountered
if($errorqty>0)
{
	$notify['type'][]='failure';
	$notify['message'][]=sprintf(TB_MSGEDITERR, $errorqty);
}
	
// count folders
$num_of_folders = (isset($dirs) ? count($dirs) : 0);

?>
<link rel="stylesheet" type="text/css" media="all" href="core/tinybrowser/css/stylefull_tinybrowser.css" />
<link rel="stylesheet" type="text/css" media="all" href="core/tinybrowser/css/style_tinybrowser.css.php" />
</head>
<body onload="rowHighlight();">
<?php
if(count($notify['type'])>0) alert($notify);
form_open('foldertab',false,'index.php','?option=filemanager&amp;path='.$path.'&amp;suboption=browse&amp;type='.$typenow);
?>
<div class="tabs">
<ul>
<li id="folders_tab" class="current"><span><a href="index.php?option=filemanager&amp;path=<?php echo $path ?>&amp;suboption=folders&amp;type=<?php echo $typenow.$passfolder; ?>"><?php echo TB_FOLDERS; ?></a></span></li>
<?php
if($tinybrowser['allowupload']) 
{
	?><li id="upload_tab"><span><a href="index.php?option=filemanager&amp;path=<?php echo $path ?>&amp;suboption=upload&amp;type=<?php echo $typenow.$passfolder ; ?>"><?php echo TB_UPLOAD; ?></a></span></li>
	<?php 
}
if($tinybrowser['allowfolders'])
{
   ?><li id="edit_tab"><span><a href="index.php?option=filemanager&amp;path=<?php echo $path ?>&amp;suboption=edit&amp;type=<?php echo $typenow.$passfolder ; ?>"><?php echo TB_EDIT; ?></a></span></li>
   <?php
  }
?>
<li id="browse_tab"><span><a href="index.php?option=filemanager&amp;path=<?php echo $path ?>&amp;suboption=browse&amp;type=<?php echo $typenow.$passfolder ; ?>"><?php echo TB_BROWSE; ?></a></span></li>
</ul>
</div>
</form>
<div class="panel_wrapper">
<div id="general_panel" class="panel currentmod">
<fieldset>
<legend><?php echo TB_FOLDERS; ?></legend>
<?php
form_open('edit','custom','index.php','?option=filemanager&amp;path='.$path.'&amp;suboption=folders&amp;type='.$typenow.$passfolder);
?>
<div class="pushleft">
<?php

// Assign edit actions based on file type and permissions
$select = array();
if($tinybrowser['allowfolders']) $select[] = array('create',TB_CREATE);
if($tinybrowser['allowdelete']) $select[] = array('delete',TB_DELETE);
if(($tinybrowser['allowedit']) AND ($path != 'studentpages')) $select[] = array('rename',TB_RENAME);

form_select($select,'editaction',TB_ACTION,$actionnow,true);
?></form></div><?php

form_open('actionform','custom','index.php','?option=filemanager&amp;path='.$path.'&amp;suboption=folders&amp;type='.$typenow.$passfolder);

if($actionnow=='move')
{ ?><div class="pushleft"><?php
   form_select($editdirs,'destination',TB_FOLDERDEST,urlencode($foldernow),false);
   ?></div><?php
} 

switch($actionnow) 
{
	case 'delete':
		$actionhead = TB_DELETE;
		break;
	case 'rename':
		$actionhead = TB_RENAME;
		break;
	case 'create':
		$actionhead = TB_CREATE;
		break;
	default:
		// do nothing
}
?><div class="tabularwrapper"><table class="browse"><tr>
<th class="nohvr"><?php echo TB_FOLDERNAME; ?></th>
<th class="nohvr"><?php echo TB_FILES; ?></th>
<th class="nohvr"><?php echo TB_DATE; ?></th>
<th class="nohvr"><?php echo $actionhead; ?></th></tr>
<?php

for($i=0;$i<$num_of_folders;$i++)
{
	$disable = ($i == 0 ? true : false);
	$alt = (IsOdd($i) ? 'r1' : 'r0');
	echo '<tr class="'.$alt.'">';
	
	if (($path == "studentpages") AND ($i > 0)) //get the pupil name when we list student dirs
	{
		$student_name = get_student_name($dirs[$i][0]) ;
	}

	echo '<td><a href="index.php?option=filemanager&amp;path='.$path.'&amp;suboption=browse&amp;type='.$typenow.'&amp;folder='.urlencode($dirs[$i][0]).'">'.$dirs[$i][2].' '. $student_name . '</a></td>';
	echo '<td>'.$dirs[$i][4].'</td><td>'.date($tinybrowser['dateformat'],$dirs[$i][5]).'</td>'
	.'<td>';
	form_hidden_input('actionfolder['.$i.']',$dirs[$i][0]);
	
	switch($actionnow) 
	{
		case 'create':
			echo '&rarr; ';
			form_text_input('createfolder['.$i.']',false,'',30,120);
		break;
		case 'delete':
			$disabledel = ($dirs[$i][4] > 0 ? ' DISABLED' : '');
			if(!$disable) echo '<input class="del" type="checkbox" name="deletefolder['.$i.']" value="1"'.$disabledel.' />';
		break;
		case 'rename':
			if((!$disable) AND ($dirs[$i][3] != "gallery") AND ($dirs[$i][3] != "downloads") AND ($dirs[$i][3] != "video")) 
			{ 
				form_text_input('renamefolder['.$i.']',false,$dirs[$i][3],30,120);
			}
			else
			{
				print "<font color=\"red\">".TB_SPECIALMAP."</font>";
			}
		break;
		default:
			// do nothing
	}
	echo "</td></tr>\n";
}

echo "</table></div>\n".'<div class="pushright">';
if($tinybrowser['allowdelete'] && $tinybrowser['allowedit'])
{
	form_hidden_input('editaction',$actionnow);
	form_submit_button('commit',$actionhead.' '.TB_FOLDERS,'edit');
}
?>
</div></fieldset></div></div>